import unittest
from unittest.mock import patch

from tmc import points
from tmc.utils import load, load_module, reload_module, get_stdout, check_source
from functools import reduce
import os
import textwrap
from random import choice, randint

exercise = 'src.movie_database'
function = 'add_movie'

def get_correct() -> dict:
    pass

def output(d: dict):
    for key in sorted(d.keys()):
        print(str(key) + ": " + str(d[key]))

@points('1.movie_database')
class MovieDatabaseTest(unittest.TestCase):
    @classmethod
    def setUpClass(cls):
        with patch('builtins.input', side_effect=[AssertionError("Att be om input från användaren förväntades inte")]):
           cls.module = load_module(exercise, 'en')

    def test_0_main_program_ok(self):
        ok, line = check_source(self.module)
        message = """Koden för att testa funktionerna ska placeras inuti
if __name__ == "__main__":
block. Följande rad ska flyttas:
"""
        self.assertTrue(ok, message+line)

    def test_1_function_exists(self):
        try:
            from src.movie_database import add_movie
        except:
            self.assertTrue(False, 'Din kod bör innehålla en funktion som heter add_movie(database: list, name: str, director: str, year: int, runtime: int)')
        try:
            add_movie = load(exercise, function, 'en')
            add_movie([], "", "", 1, 1)
        except:
            self.assertTrue(False, 'Se till att den funktionen kan anropas som\nadd_movie([], "", "", 1, 1)')


    def test_2_type_of_return_value(self):
        add_movie = load(exercise, function, 'en')
        val = add_movie([], "", "", 1, 1)
        taip = str(type(val)).replace("<class '", '').replace("'>","")
        self.assertTrue(val == None, f"Funktionen {function} ska returnera dictionary, nu returnerar den ett värde som är {taip} typ")
    
    def test_3_one_movie(self):
        test_cases = (("The Birds", "Alfred Hitchcock", 1963, 119), ("The Godfather", "Francis Ford Coppola", 1972, 175))
        for test_case in test_cases:
            with patch('builtins.input', side_effect=[AssertionError("Att be om input från användaren förväntades inte")]):
                reload_module(self.module)
                output_at_start = get_stdout()

                add_movie = load(exercise, function, 'en')

                movielist = []
                
                correct = [{x : y for x,y in zip(("name","director","year","runtime"), test_case)}]
                add_movie(movielist, test_case[0], test_case[1], test_case[2], test_case[3])
                

                self.assertEqual(len(correct), len(movielist), f"Efter tillägget bör listan innehålla {len(correct)} objekt, men den innehåller {len(movielist)} objekt: \n{movielist} när parametrarna är \n{test_case}")
                self.assertEqual(correct, movielist, f"Resultatet\n{movielist}\nmatchar inte med modelllösningen\n{correct}\när parametrarna är\n{test_case}")

    def test_3_several_movies(self):
        test_cases = (("The Birds", "Alfred Hitchcock", 1963, 119),
                      ("The Godfather", "Francis Ford Coppola", 1972, 175),
                      ("Jaws", "Steven Spielberg", 1975, 124),
                      ("Star Wars", "George Lucas", 1977, 121))
        movielist = []
        correct = []
        for test_case in test_cases:
            with patch('builtins.input', side_effect=[AssertionError("Att be om input från användaren förväntades inte")]):
                reload_module(self.module)
                output_at_start = get_stdout()
                add_movie = load(exercise, function, 'en')

                correct.append({x : y for x,y in zip(("name","director","year","runtime"), test_case)})
                add_movie(movielist, test_case[0], test_case[1], test_case[2], test_case[3])
                
                self.assertEqual(len(correct), len(movielist), f"Efter tillägget bör listan innehålla {len(correct)} objekt;\n{correct}, men den innehåller {len(movielist)} objekt: \n{movielist} när parametrarna är \n{test_case}")
                self.assertEqual(correct, movielist, f"Resultatet\och{movielist}\matchar inte med modelllösningen\n{correct}\när parametrarna är\n{test_case}")
              
if __name__ == '__main__':
    unittest.main()
